// $Id: jquery.netforum.js,v 1.4 2009/10/18 17:14:55 jamesmichaelhill Exp $


if (Drupal.jsEnabled){
  $(document).ready(function(){
    //first step, bind to the change event for our function drop down list
    $('#edit-netforum-request').change(function(){
        return updateParameterForm();
      });
      //second step, swap out the four default parameters that drupal renders
      //and swap in the parameters for whatever is selected

      updateParameterForm();
  });
}

function getParamsForSelectedFunction() {
  return xweb_functions[getSelectedFunction()];
}

function getSelectedFunction() {
  return $('#edit-netforum-request').val();
}

//this is just a wrapper to animate the form changes
function updateParameterForm() {

  $('#parameters').hide("fast");
  if (getParamsForSelectedFunction() == "parameters") {
    $.getJSON(document.URL + "/params_for/" + getSelectedFunction(), {}, function(json){
      xweb_functions[getSelectedFunction()] = json;
      updateParameters(getParamsForSelectedFunction());
      $('#parameters').show("normal");
    });
  }
  else {
    updateParameters(getParamsForSelectedFunction());
    $('#parameters').show("normal");
  }

}


//This function looks at the selected function, references it with an array placed in the page
//header by the drupal render, and adjusts the fields displayed.  They are all named
//netforum_param_1, netforum_param_2, etc
function updateParameters(parameter_list) {
    
  //the xweb_functions variable is included in the head of the page by the module.
  //it is an array with the function names and the parameters listed

  var paramsDiv = $('#parameters');
  paramsDiv.empty();
  if (parameter_list.length == 0) {
    paramsDiv.html("<i>no parameters</i>");
  }
  else {
    addParamsInto(paramsDiv[0], parameter_list);    
  }
}

function addParamsInto(paramsDiv, parameter_list) {
  if (typeof(addParamsInto.paramId) == "undefined") {
    addParamsInto.paramId = 0;
  }
  
  if (typeof(addParamsInto.objStack) == "undefined") {
    addParamsInto.objStack = [];
  }
  
  jQuery.each(parameter_list, function(key, val) {
    if (typeof(val) == "string") {
      addParamsInto.paramId += 1;
    	paramsDiv.appendChild(buildInputDiv(addParamsInto.paramId, val, addParamsInto.objStack));
    }
    else if (typeof(val) == "object") {
      addParamsInto.objStack.push(key);
    	var legend = document.createElement('legend');
    	legend.innerHTML = key;
    	
      var newFieldset = document.createElement('fieldset');
    	newFieldset.setAttribute('class', 'collapsible collapsed');
    	newFieldset.appendChild(legend);

    	addParamsInto(newFieldset, val);
    	
    	paramsDiv.appendChild(newFieldset);
      reBindFieldsets();
      addParamsInto.objStack.pop();
    }
  });
}

function buildInputDiv(pnum, pname, stack) {
  var prefix = "";
  if (stack.length > 0) {
    prefix = "[" + stack.join("][") + "]"; 
  }
  
  var newDiv = document.createElement('div');
	newDiv.setAttribute('id', 'netforum_custom_'+pnum);
	newDiv.setAttribute('class', 'form-item');

	var newLabel = document.createElement('label');
	newLabel.setAttribute('for', 'edit-netforum-param-'+pnum);
	newLabel.innerHTML = pname + ":";
	newDiv.appendChild(newLabel);

	var newInput = document.createElement('input');
	newInput.setAttribute('type', 'text');
	newInput.setAttribute('maxlength', '2000');
	newInput.setAttribute('name', 'netforum_params'+prefix+"["+pname+"]");
	newInput.setAttribute('id', 'edit-netforum-param-'+pnum);
	newInput.setAttribute('size', 60);
	newInput.setAttribute('class', 'form-text');
	
  // When we are redisplaying a form, this var will be populated.  We work through
  // the stack and walk through the vars to set the defaults
	if (typeof(form_defaults) != "undefined" && form_defaults[getSelectedFunction()]) {
	  var tmpStack = stack,
	      tmpStackLen = stack.length,
	      defaults = form_defaults[getSelectedFunction()];

	  for (i=0;i<tmpStackLen;i++) {
	    if (typeof(defaults[tmpStack[i]]) != "undefined") {
	      defaults = defaults[tmpStack[i]];
	    }
	  }
	  if (typeof(defaults[pname]) != "undefined") {
	    newInput.value = defaults[pname]; 
	  }
	}
	newDiv.appendChild(newInput);
	return newDiv;
}

//Same thing as the document redy function in drupal's collapse.js
function reBindFieldsets() {
  $('fieldset.collapsible > legend').each(function() {
    var fieldset = $(this.parentNode);
    // Expand if there are errors inside
    if ($('input.error, textarea.error, select.error', fieldset).size() > 0) {
      fieldset.removeClass('collapsed');
    }

    // Turn the legend into a clickable link and wrap the contents of the fieldset
    // in a div for easier animation
    var text = this.innerHTML;
    $(this).empty().append($('<a href="#">'+ text +'</a>').click(function() {
      var fieldset = $(this).parents('fieldset:first')[0];
      // Don't animate multiple times
      if (!fieldset.animating) {
        fieldset.animating = true;
        Drupal.toggleFieldset(fieldset);
      }
      return false;
    })).after($('<div class="fieldset-wrapper"></div>').append(fieldset.children(':not(legend)')));
  });
}